scala.collection.immutable

# TreeMap

###
Related Docs: object TreeMap | package immutable

#### class TreeMap[A, +B] extends SortedMap[A, B] with SortedMapLike[A, B, TreeMap[A, B]] with MapLike[A, B, TreeMap[A, B]] with Serializable

This class implements immutable maps using a tree.

A

  the type of the keys contained in this tree map.

B

  the type of the values associated with the keys.

Annotations
  @deprecatedInheritance( ... , "2.11.0" )
Source
  TreeMap.scala
Version

  1.1, 03/05/2004

Since

  1

See also

  "Scala's Collection Library overview" section on `Red-Black Trees` for more information.

Linear Supertypes
Serializable, java.io.Serializable, SortedMap[A, B], collection.SortedMap[A, B], SortedMapLike[A, B, TreeMap[A, B]], Sorted[A, TreeMap[A, B]], Map[A, B], MapLike[A, B, TreeMap[A, B]], collection.Map[A, B], collection.MapLike[A, B, TreeMap[A, B]], Subtractable[A, TreeMap[A, B]], PartialFunction[A, B], (A) ⇒ B, GenMap[A, B], GenMapLike[A, B, TreeMap[A, B]], Iterable[(A, B)], collection.Iterable[(A, B)], IterableLike[(A, B), TreeMap[A, B]], Equals, GenIterable[(A, B)], GenIterableLike[(A, B), TreeMap[A, B]], Traversable[(A, B)], Immutable, collection.Traversable[(A, B)], GenTraversable[(A, B)], GenericTraversableTemplate[(A, B), Iterable], TraversableLike[(A, B), TreeMap[A, B]], GenTraversableLike[(A, B), TreeMap[A, B]], Parallelizable[(A, B), ParMap[A, B]], TraversableOnce[(A, B)], GenTraversableOnce[(A, B)], FilterMonadic[(A, B), TreeMap[A, B]], HasNewBuilder[(A, B), TreeMap[A, B]], AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. TreeMap
2. Serializable
3. Serializable
4. SortedMap
5. SortedMap
6. SortedMapLike
7. Sorted
8. Map
9. MapLike
10. Map
11. MapLike
12. Subtractable
13. PartialFunction
14. Function1
15. GenMap
16. GenMapLike
17. Iterable
18. Iterable
19. IterableLike
20. Equals
21. GenIterable
22. GenIterableLike
23. Traversable
24. Immutable
25. Traversable
26. GenTraversable
27. GenericTraversableTemplate
28. TraversableLike
29. GenTraversableLike
30. Parallelizable
31. TraversableOnce
32. GenTraversableOnce
33. FilterMonadic
34. HasNewBuilder
35. AnyRef
36. Any

Implicitly

1. by CollectionsHaveToParArray
2. by MonadOps
3. by any2stringadd
4. by StringFormat
5. by Ensuring
6. by ArrowAssoc
7. by alternateImplicit

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new TreeMap()(implicit ordering: Ordering[A])

### Type Members

1. #### class DefaultKeySet extends AbstractSet[A] with Set[A] with Serializable

   The implementation class of the set returned by `keySet`.

   The implementation class of the set returned by `keySet`.

   Attributes
     protected
   Definition Classes
     MapLike

2. #### class DefaultKeySortedSet extends SortedMap.DefaultKeySortedSet with SortedSet[A]

   Attributes
     protected
   Definition Classes
     SortedMap

3. #### class DefaultValuesIterable extends AbstractIterable[B] with Iterable[B] with Serializable

   The implementation class of the iterable returned by `values`.

   The implementation class of the iterable returned by `values`.

   Attributes
     protected
   Definition Classes
     MapLike

4. #### class FilteredKeys extends AbstractMap[A, B] with DefaultMap[A, B]

   Attributes
     protected
   Definition Classes
     MapLike

5. #### class ImmutableDefaultKeySet extends DefaultKeySet with Set[A]

   Attributes
     protected
   Definition Classes
     MapLike

6. #### class MappedValues[C] extends AbstractMap[A, C] with DefaultMap[A, C]

   Attributes
     protected
   Definition Classes
     MapLike

7. #### type Self = TreeMap[A, B]

   The type implementing this traversable

   The type implementing this traversable

   Attributes
     protected[this]
   Definition Classes
     TraversableLike

8. #### class WithFilter extends FilterMonadic[A, Repr]

   A class supporting filtered operations.

   A class supporting filtered operations. Instances of this class are returned by method `withFilter`.

   Definition Classes
     TraversableLike

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +[B1 >: B](elem1: (A, B1), elem2: (A, B1), elems: (A, B1)*): TreeMap[A, B1]

   Adds two or more elements to this collection and returns either the collection itself (if it is mutable), or a new collection with the added elements.

   Adds two or more elements to this collection and returns either the collection itself (if it is mutable), or a new collection with the added elements.

   B1

     type of the values of the new bindings, a supertype of `B`

   elem1

     the first element to add.

   elem2

     the second element to add.

   elems

     the remaining elements to add.

   returns

     a new immutable tree map with the updated bindings

   Definition Classes
     TreeMap → SortedMap → SortedMapLike → MapLike → MapLike

4. #### def +[B1 >: B](kv: (A, B1)): TreeMap[A, B1]

   Add a key/value pair to this map.

   Add a key/value pair to this map.

   B1

     type of the value of the new binding, a supertype of `B`

   kv

     the key/value pair

   returns

     A new immutable tree map with the new binding added to this map

   Definition Classes
     TreeMap → SortedMap → SortedMapLike → Map → MapLike → MapLike → GenMapLike

5. #### def ++[B1 >: B](xs: GenTraversableOnce[(A, B1)]): TreeMap[A, B1]

   Adds a number of elements provided by a traversable object and returns a new collection with the added elements.

   Adds a number of elements provided by a traversable object and returns a new collection with the added elements.

   B1

     the type of the added values

   xs

     the traversable object.

   returns

     a new map with the given bindings added to this map

   Definition Classes
     TreeMap → SortedMap → SortedMapLike → MapLike → MapLike

6. #### def ++[B](that: GenTraversableOnce[B]): TreeMap[B]

   [use case] Returns a new immutable tree map containing the elements from the left hand operand followed by the elements from the right hand operand.

   [use case]

   Returns a new immutable tree map containing the elements from the left hand operand followed by the elements from the right hand operand. The element type of the immutable tree map is the most specific superclass encompassing the element types of the two operands.

   Example:

       scala> val a = List(1)
       a: List[Int] = List(1)

       scala> val b = List(2)
       b: List[Int] = List(2)

       scala> val c = a ++ b
       c: List[Int] = List(1, 2)

       scala> val d = List('a')
       d: List[Char] = List(a)

       scala> val e = c ++ d
       e: List[AnyVal] = List(1, 2, a)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new immutable tree map which contains all elements of this immutable tree map followed by all elements of `that`.

   Definition Classes
     TraversableLike → GenTraversableLike
   Full Signature

   #### def ++[B >: (A, B), That](that: GenTraversableOnce[B])(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

7. #### def ++:[B >: (A, B), That](that: collection.Traversable[B])(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   This overload exists because: for the implementation of `++:` we should reuse that of `++` because many collections override it with more efficient versions.

   Since `TraversableOnce` has no `++` method, we have to implement that directly, but `Traversable` and down can use the overload.

   B

     the element type of the returned collection.

   That

     the class of the returned collection. Where possible, `That` is the same class as the current collection class `Repr`, but this depends on the element type `B` being admissible for that class, which means that an implicit instance of type `CanBuildFrom[Repr, B, That]` is found.

   that

     the traversable to append.

   bf

     an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

   returns

     a new collection of type `That` which contains all elements of this traversable collection followed by all elements of `that`.

   Definition Classes
     TraversableLike

8. #### def ++:[B](that: TraversableOnce[B]): TreeMap[B]

   [use case] As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   [use case]

   As with `++`, returns a new collection containing the elements from the left operand followed by the elements from the right operand.

   It differs from `++` in that the right operand determines the type of the resulting collection rather than the left one. Mnemonic: the COLon is on the side of the new COLlection type.

   Example:

       scala> val x = List(1)
       x: List[Int] = List(1)

       scala> val y = LinkedList(2)
       y: scala.collection.mutable.LinkedList[Int] = LinkedList(2)

       scala> val z = x ++: y
       z: scala.collection.mutable.LinkedList[Int] = LinkedList(1, 2)

   B

     the element type of the returned collection.

   that

     the traversable to append.

   returns

     a new immutable tree map which contains all elements of this immutable tree map followed by all elements of `that`.

   Definition Classes
     TraversableLike
   Full Signature

   #### def ++:[B >: (A, B), That](that: TraversableOnce[B])(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

9. #### def -(key: A): collection.Map[A, B]

   [use case] Removes a key from this map, returning a new map.

   [use case]

   Removes a key from this map, returning a new map.

   key

     the key to be removed

   returns

     a new map without a binding for `key`

   Definition Classes
     TreeMap → MapLike → Subtractable → GenMapLike
   Full Signature

   #### def -(key: A): TreeMap[A, B]

10. #### def -(elem1: A, elem2: A, elems: A*): TreeMap[A, B]

    Creates a new collection from this collection with some elements removed.

    Creates a new collection from this collection with some elements removed.

    This method takes two or more elements to be removed. Another overloaded variant of this method handles the case where a single element is removed.

    elem1

      the first element to remove.

    elem2

      the second element to remove.

    elems

      the remaining elements to remove.

    returns

      a new collection that contains all elements of the current collection except one less occurrence of each of the given elements.

    Definition Classes
      Subtractable

11. #### def --(xs: GenTraversableOnce[A]): TreeMap[A, B]

    Creates a new collection from this collection by removing all elements of another collection.

    Creates a new collection from this collection by removing all elements of another collection.

    xs

      the collection containing the removed elements.

    returns

      a new collection that contains all elements of the current collection except one less occurrence of each of the elements of `elems`.

    Definition Classes
      Subtractable

12. #### def ->[B](y: B): (TreeMap[A, B], B)

    Implicit information
      This member is added by an implicit conversion from TreeMap[A, B] to ArrowAssoc[TreeMap[A, B]] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
    Annotations
      @inline()

13. #### def /:[B](z: B)(op: (B, (A, B)) ⇒ B): B

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Note: `/:` is alternate syntax for `foldLeft`; `z /: xs` is the same as `xs foldLeft z`.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = (5 /: a)(_+_)
        b: Int = 15

        scala> val c = (5 /: a)((x,y) => x + y)
        c: Int = 15

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

          op(...op(op(z, x_1), x_2), ..., x_n)

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

14. #### def :\[B](z: B)(op: ((A, B), B) ⇒ B): B

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Applies a binary operator to all elements of this traversable or iterator and a start value, going right to left.

    Note: `:\` is alternate syntax for `foldRight`; `xs :\ z` is the same as `xs foldRight z`.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    Examples:

    Note that the folding function used to compute b is equivalent to that used to compute c.

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = (a :\ 5)(_+_)
        b: Int = 15

        scala> val c = (a :\ 5)((x,y) => x + y)
        c: Int = 15

    B

      the result type of the binary operator.

    z

      the start value

    op

      the binary operator

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

15. #### final def ==(arg0: Any): Boolean

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

    arg0

      the object to compare against this object for equality.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def addString(b: StringBuilder, start: String, sep: String, end: String): StringBuilder

    Appends all bindings of this map to a string builder using start, end, and separator strings.

    Appends all bindings of this map to a string builder using start, end, and separator strings. The written text begins with the string `start` and ends with the string `end`. Inside, the string representations of all bindings of this map in the form of `key -> value` are separated by the string `sep`.

    b

      the builder to which strings are appended.

    start

      the starting string.

    sep

      the separator string.

    end

      the ending string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      MapLike → TraversableOnce

17. #### def addString(b: StringBuilder): StringBuilder

    Appends all elements of this traversable or iterator to a string builder.

    Appends all elements of this traversable or iterator to a string builder. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator without any separator string.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> val h = a.addString(b)
        h: StringBuilder = 1234

    b

      the string builder to which elements are appended.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

18. #### def addString(b: StringBuilder, sep: String): StringBuilder

    Appends all elements of this traversable or iterator to a string builder using a separator string.

    Appends all elements of this traversable or iterator to a string builder using a separator string. The written text consists of the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator, separated by the string `sep`.

    Example:

        scala> val a = List(1,2,3,4)
        a: List[Int] = List(1, 2, 3, 4)

        scala> val b = new StringBuilder()
        b: StringBuilder =

        scala> a.addString(b, ", ")
        res0: StringBuilder = 1, 2, 3, 4

    b

      the string builder to which elements are appended.

    sep

      the separator string.

    returns

      the string builder `b` to which elements were appended.

    Definition Classes
      TraversableOnce

19. #### def aggregate[B](z: ⇒ B)(seqop: (B, (A, B)) ⇒ B, combop: (B, B) ⇒ B): B

    Aggregates the results of applying an operator to subsequent elements.

    Aggregates the results of applying an operator to subsequent elements.

    This is a more general form of `fold` and `reduce`. It has similar semantics, but does not require the result to be a supertype of the element type. It traverses the elements in different partitions sequentially, using `seqop` to update the result, and then applies `combop` to results from different partitions. The implementation of this operation may operate on an arbitrary number of collection partitions, so `combop` may be invoked an arbitrary number of times.

    For example, one might want to process some elements and then produce a `Set`. In this case, `seqop` would process an element and append it to the list, while `combop` would concatenate two lists from different partitions together. The initial value `z` would be an empty set.

        pc.aggregate(Set[Int]())(_ += process(_), _ ++ _)

    Another example is calculating geometric mean from a collection of doubles (one would typically require big doubles for this).

    B

      the type of accumulated results

    z

      the initial value for the accumulated result of the partition - this will typically be the neutral element for the `seqop` operator (e.g. `Nil` for list concatenation or `0` for summation) and may be evaluated more than once

    seqop

      an operator used to accumulate results within a partition

    combop

      an associative operator used to combine results from different partitions

    Definition Classes
      TraversableOnce → GenTraversableOnce

20. #### def andThen[C](k: (B) ⇒ C): PartialFunction[A, C]

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    Composes this partial function with a transformation function that gets applied to results of this partial function.

    C

      the result type of the transformation function.

    k

      the transformation function

    returns

      a partial function with the same domain as this partial function, which maps arguments `x` to `k(this(x))`.

    Definition Classes
      PartialFunction → Function1

21. #### def apply(key: A): B

    Retrieves the value which is associated with the given key.

    Retrieves the value which is associated with the given key. This method invokes the `default` method of the map if there is no mapping from the given key to a value. Unless overridden, the `default` method throws a `NoSuchElementException`.

    key

      the key

    returns

      the value associated with the given key, or the result of the map's `default` method, if none exists.

    Definition Classes
      MapLike → GenMapLike → Function1

22. #### def applyOrElse[A1 <: A, B1 >: B](x: A1, default: (A1) ⇒ B1): B1

    Applies this partial function to the given argument when it is contained in the function domain.

    Applies this partial function to the given argument when it is contained in the function domain. Applies fallback function where this partial function is not defined.

    Note that expression `pf.applyOrElse(x, default)` is equivalent to

        if(pf isDefinedAt x) pf(x) else default(x)

    except that `applyOrElse` method can be implemented more efficiently. For all partial function literals the compiler generates an `applyOrElse` implementation which avoids double evaluation of pattern matchers and guards. This makes `applyOrElse` the basis for the efficient implementation for many operations and scenarios, such as:

    - combining partial functions into `orElse`/`andThen` chains does not lead to excessive `apply`/`isDefinedAt` evaluation
    - `lift` and `unlift` do not evaluate source functions twice on each invocation
    - `runWith` allows efficient imperative-style combining of partial functions with conditionally applied actions

    For non-literal partial function classes with nontrivial `isDefinedAt` method it is recommended to override `applyOrElse` with custom implementation that avoids double `isDefinedAt` evaluation. This may result in better performance and more predictable behavior w.r.t. side effects.

    x

      the function argument

    default

      the fallback function

    returns

      the result of this function or fallback function application.

    Definition Classes
      PartialFunction
    Since

      2.10

23. #### final def asInstanceOf[T0]: T0

    Cast the receiver object to be of type `T0`.

    Cast the receiver object to be of type `T0`.

    Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

    returns

      the receiver object.

    Definition Classes
      Any
    Exceptions thrown

      `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

24. #### def canEqual(that: Any): Boolean

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    Method called from equality methods, so that user-defined subclasses can refuse to be equal to other collections of the same kind.

    that

      The object with which this iterable collection should be compared

    returns

      `true`, if this iterable collection can possibly equal `that`, `false` otherwise. The test takes into consideration only the run-time types of objects but ignores their elements.

    Definition Classes
      IterableLike → Equals

25. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

26. #### def collect[B](pf: PartialFunction[A, B]): TreeMap[B]

    [use case] Builds a new collection by applying a partial function to all elements of this immutable tree map on which the function is defined.

    [use case]

    Builds a new collection by applying a partial function to all elements of this immutable tree map on which the function is defined.

    B

      the element type of the returned collection.

    pf

      the partial function which filters and maps the immutable tree map.

    returns

      a new immutable tree map resulting from applying the given partial function `pf` to each element on which it is defined and collecting the results. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike
    Full Signature

    #### def collect[B, That](pf: PartialFunction[(A, B), B])(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

27. #### def collectFirst[B](pf: PartialFunction[(A, B), B]): Option[B]

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Finds the first element of the traversable or iterator for which the given partial function is defined, and applies the partial function to it.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    pf

      the partial function

    returns

      an option value containing pf applied to the first value for which it is defined, or `None` if none exists.

    Definition Classes
      TraversableOnce
    Example:

    1. `Seq("a", 1, 5L).collectFirst({ case x: Int => x*10 }) = Some(10)`

28. #### def companion: GenericCompanion[Iterable]

    The factory companion object that builds instances of class `immutable.Iterable`.

    The factory companion object that builds instances of class `immutable.Iterable`. (or its `Iterable` superclass where class `immutable.Iterable` is not a `Seq`.)

    Definition Classes
      Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → GenericTraversableTemplate

29. #### def compare(k0: A, k1: A): Int

    Comparison function that orders keys.

    Comparison function that orders keys.

    Definition Classes
      TreeMap → Sorted

30. #### def compose[A](g: (A) ⇒ A): (A) ⇒ B

    Composes two instances of Function1 in a new Function1, with this function applied last.

    Composes two instances of Function1 in a new Function1, with this function applied last.

    A

      the type to which function `g` can be applied

    g

      a function A => T1

    returns

      a new function `f` such that `f(x) == apply(g(x))`

    Definition Classes
      Function1
    Annotations
      @unspecialized()

31. #### def contains(key: A): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      TreeMap → MapLike → GenMapLike

32. #### def copyToArray(xs: Array[A], start: Int, len: Int): Unit

    [use case] Copies elements of this immutable tree map to an array.

    [use case]

    Copies elements of this immutable tree map to an array. Fills the given array `xs` with at most `len` elements of this immutable tree map, starting at position `start`. Copying will stop once either the end of the current immutable tree map is reached, or the end of the array is reached, or `len` elements have been copied.

    xs

      the array to fill.

    start

      the starting index.

    len

      the maximal number of elements to copy.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: (A, B)](xs: Array[B], start: Int, len: Int): Unit

33. #### def copyToArray(xs: Array[A]): Unit

    [use case] Copies values of this immutable tree map to an array.

    [use case]

    Copies values of this immutable tree map to an array. Fills the given array `xs` with values of this immutable tree map. Copying will stop once either the end of the current immutable tree map is reached, or the end of the array is reached.

    xs

      the array to fill.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: (A, B)](xs: Array[B]): Unit

34. #### def copyToArray(xs: Array[A], start: Int): Unit

    [use case] Copies values of this immutable tree map to an array.

    [use case]

    Copies values of this immutable tree map to an array. Fills the given array `xs` with values of this immutable tree map, beginning at index `start`. Copying will stop once either the end of the current immutable tree map is reached, or the end of the array is reached.

    xs

      the array to fill.

    start

      the starting index.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def copyToArray[B >: (A, B)](xs: Array[B], start: Int): Unit

35. #### def copyToBuffer[B >: (A, B)](dest: Buffer[B]): Unit

    Copies all elements of this traversable or iterator to a buffer.

    Copies all elements of this traversable or iterator to a buffer.

    Note: will not terminate for infinite-sized collections.

    dest

      The buffer to which elements are copied.

    Definition Classes
      TraversableOnce

36. #### def count(p: ((A, B)) ⇒ Boolean): Int

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    Counts the number of elements in the traversable or iterator which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      the number of elements satisfying the predicate `p`.

    Definition Classes
      TraversableOnce → GenTraversableOnce

37. #### def default(key: A): B

    Defines the default value computation for the map, returned when a key is not found The method implemented here throws an exception, but it might be overridden in subclasses.

    Defines the default value computation for the map, returned when a key is not found The method implemented here throws an exception, but it might be overridden in subclasses.

    key

      the given key value for which a binding is missing.

    Definition Classes
      MapLike → GenMapLike
    Exceptions thrown

      `NoSuchElementException`

38. #### def drop(n: Int): TreeMap[A, B]

    Selects all elements except first n ones.

    Selects all elements except first n ones.

    n

      the number of elements to drop from this immutable tree map.

    returns

      a immutable tree map consisting of all elements of this immutable tree map except the first `n` ones, or else the empty immutable tree map, if this immutable tree map has less than `n` elements.

    Definition Classes
      TreeMap → IterableLike → TraversableLike → GenTraversableLike

39. #### def dropRight(n: Int): TreeMap[A, B]

    Selects all elements except last n ones.

    Selects all elements except last n ones.

    n

      The number of elements to take

    returns

      a immutable tree map consisting of all elements of this immutable tree map except the last `n` ones, or else the empty immutable tree map, if this immutable tree map has less than `n` elements.

    Definition Classes
      TreeMap → IterableLike

40. #### def dropWhile(p: ((A, B)) ⇒ Boolean): TreeMap[A, B]

    Drops longest prefix of elements that satisfy a predicate.

    Drops longest prefix of elements that satisfy a predicate.

    returns

      the longest suffix of this immutable tree map whose first element does not satisfy the predicate `p`.

    Definition Classes
      TreeMap → TraversableLike → GenTraversableLike

41. #### def empty: TreeMap[A, B]

    A factory to create empty maps of the same type of keys.

    A factory to create empty maps of the same type of keys.

    returns

      an empty map of type `This`.

    Definition Classes
      TreeMap → SortedMap → SortedMap → Map → Map → MapLike

42. #### def ensuring(cond: (TreeMap[A, B]) ⇒ Boolean, msg: ⇒ Any): TreeMap[A, B]

    Implicit information
      This member is added by an implicit conversion from TreeMap[A, B] to Ensuring[TreeMap[A, B]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

43. #### def ensuring(cond: (TreeMap[A, B]) ⇒ Boolean): TreeMap[A, B]

    Implicit information
      This member is added by an implicit conversion from TreeMap[A, B] to Ensuring[TreeMap[A, B]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

44. #### def ensuring(cond: Boolean, msg: ⇒ Any): TreeMap[A, B]

    Implicit information
      This member is added by an implicit conversion from TreeMap[A, B] to Ensuring[TreeMap[A, B]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

45. #### def ensuring(cond: Boolean): TreeMap[A, B]

    Implicit information
      This member is added by an implicit conversion from TreeMap[A, B] to Ensuring[TreeMap[A, B]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

46. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

47. #### def equals(that: Any): Boolean

    Compares two maps structurally; i.e., checks if all mappings contained in this map are also contained in the other map, and vice versa.

    Compares two maps structurally; i.e., checks if all mappings contained in this map are also contained in the other map, and vice versa.

    that

      the other map

    returns

      `true` if both maps contain exactly the same mappings, `false` otherwise.

    Definition Classes
      GenMapLike → Equals → AnyRef → Any

48. #### def exists(p: ((A, B)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for some of the elements of this iterable collection.

    Tests whether a predicate holds for some of the elements of this iterable collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `false` if this iterable collection is empty, otherwise `true` if the given predicate `p` holds for some of the elements of this iterable collection, otherwise `false`

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

49. #### def filter(p: ((A, B)) ⇒ Boolean): TreeMap[A, B]

    Selects all elements of this traversable collection which satisfy a predicate.

    Selects all elements of this traversable collection which satisfy a predicate.

    p

      the predicate used to test elements.

    returns

      a new traversable collection consisting of all elements of this traversable collection that satisfy the given predicate `p`. The order of the elements is preserved.

    Definition Classes
      TraversableLike → GenTraversableLike

50. #### def filterKeys(p: (A) ⇒ Boolean): SortedMap[A, B]

    Filters this map by retaining only keys satisfying a predicate.

    Filters this map by retaining only keys satisfying a predicate.

    p

      the predicate used to test keys

    returns

      an immutable map consisting only of those key value pairs of this map where the key satisfies the predicate `p`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      SortedMap → SortedMapLike → MapLike → MapLike → GenMapLike

51. #### def filterNot(p: ((A, B)) ⇒ Boolean): TreeMap[A, B]

    Returns a new map obtained by removing all key/value pairs for which the predicate `p` returns `true`.

    Returns a new map obtained by removing all key/value pairs for which the predicate `p` returns `true`.

    Note: This method works by successively removing elements for which the predicate is true from this set. If removal is slow, or you expect that most elements of the set will be removed, you might consider using `filter` with a negated predicate instead.

    p

      A predicate over key-value pairs

    returns

      A new map containing elements not satisfying the predicate.

    Definition Classes
      MapLike → TraversableLike → GenTraversableLike

52. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

53. #### def find(p: ((A, B)) ⇒ Boolean): Option[(A, B)]

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Finds the first element of the iterable collection satisfying a predicate, if any.

    Note: may not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered.

    p

      the predicate used to test elements.

    returns

      an option value containing the first element in the iterable collection that satisfies `p`, or `None` if none exists.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

54. #### def firstKey: A

    Returns the first key of the collection.

    Returns the first key of the collection.

    Definition Classes
      TreeMap → SortedMapLike → Sorted

55. #### def flatMap[B](f: (A) ⇒ GenTraversableOnce[B]): TreeMap[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable tree map and using the elements of the resulting collections.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable tree map and using the elements of the resulting collections.

    For example:

        def getWords(lines: Seq[String]): Seq[String] = lines flatMap (line => line split "\\W+")

    The type of the resulting collection is guided by the static type of immutable tree map. This might cause unexpected results sometimes. For example:

        // lettersOf will return a Seq[Char] of likely repeated letters, instead of a Set
        def lettersOf(words: Seq[String]) = words flatMap (word => word.toSet)

        // lettersOf will return a Set[Char], not a Seq
        def lettersOf(words: Seq[String]) = words.toSet flatMap (word => word.toSeq)

        // xs will be an Iterable[Int]
        val xs = Map("a" -> List(11,111), "b" -> List(22,222)).flatMap(_._2)

        // ys will be a Map[Int, Int]
        val ys = Map("a" -> List(1 -> 11,1 -> 111), "b" -> List(2 -> 22,2 -> 222)).flatMap(_._2)

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new immutable tree map resulting from applying the given collection-valued function `f` to each element of this immutable tree map and concatenating the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def flatMap[B, That](f: ((A, B)) ⇒ GenTraversableOnce[B])(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

56. #### def flatten[B]: TreeMap[B]

    [use case] Converts this immutable tree map of traversable collections into a immutable tree map formed by the elements of these traversable collections.

    [use case]

    Converts this immutable tree map of traversable collections into a immutable tree map formed by the elements of these traversable collections.

    The resulting collection's type will be guided by the static type of immutable tree map. For example:

        val xs = List(
                   Set(1, 2, 3),
                   Set(1, 2, 3)
                 ).flatten
        // xs == List(1, 2, 3, 1, 2, 3)

        val ys = Set(
                   List(1, 2, 3),
                   List(3, 2, 1)
                 ).flatten
        // ys == Set(1, 2, 3)

    B

      the type of the elements of each traversable collection.

    returns

      a new immutable tree map resulting from concatenating all element immutable tree maps.

    Definition Classes
      GenericTraversableTemplate
    Full Signature

    #### def flatten[B](implicit asTraversable: ((A, B)) ⇒ GenTraversableOnce[B]): Iterable[B]

57. #### def fold[A1 >: (A, B)](z: A1)(op: (A1, A1) ⇒ A1): A1

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    Folds the elements of this traversable or iterator using the specified associative binary operator.

    The order in which operations are performed on elements is unspecified and may be nondeterministic.

    A1

      a type parameter for the binary operator, a supertype of `A`.

    z

      a neutral element for the fold operation; may be added to the result an arbitrary number of times, and must not change the result (e.g., `Nil` for list concatenation, 0 for addition, or 1 for multiplication.)

    op

      a binary operator that must be associative

    returns

      the result of applying fold operator `op` between all the elements and `z`

    Definition Classes
      TraversableOnce → GenTraversableOnce

58. #### def foldLeft[B](z: B)(op: (B, (A, B)) ⇒ B): B

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Applies a binary operator to a start value and all elements of this traversable or iterator, going left to right.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right with the start value `z` on the left:

          op(...op(z, x_1), x_2, ..., x_n)

      where `x1, ..., xn` are the elements of this traversable or iterator.

    Definition Classes
      TraversableOnce → GenTraversableOnce

59. #### def foldRight[B](z: B)(op: ((A, B), B) ⇒ B): B

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Applies a binary operator to all elements of this iterable collection and a start value, going right to left.

    Note: will not terminate for infinite-sized collections.

    Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

    B

      the result type of the binary operator.

    z

      the start value.

    op

      the binary operator.

    returns

      the result of inserting `op` between consecutive elements of this iterable collection, going right to left with the start value `z` on the right:

          op(x_1, op(x_2, ... op(x_n, z)...))

      where `x1, ..., xn` are the elements of this iterable collection.

    Definition Classes
      IterableLike → TraversableOnce → GenTraversableOnce

60. #### def forall(p: ((A, B)) ⇒ Boolean): Boolean

    Tests whether a predicate holds for all elements of this iterable collection.

    Tests whether a predicate holds for all elements of this iterable collection.

    Note: may not terminate for infinite-sized collections.

    p

      the predicate used to test elements.

    returns

      `true` if this iterable collection is empty, otherwise `true` if the given predicate `p` holds for all elements of this iterable collection, otherwise `false`.

    Definition Classes
      IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

61. #### def foreach(f: (A) ⇒ Unit): Unit

    [use case] Applies a function `f` to all elements of this immutable tree map.

    [use case]

    Applies a function `f` to all elements of this immutable tree map.

    Note: this method underlies the implementation of most other bulk operations. Subclasses should re-implement this method if a more efficient implementation exists.

    f

      the function that is applied for its side-effect to every element. The result of function `f` is discarded.

    Definition Classes
      TreeMap → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike → TraversableOnce → GenTraversableOnce → FilterMonadic
    Full Signature

    #### def foreach[U](f: ((A, B)) ⇒ U): Unit

62. #### def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit information
      This member is added by an implicit conversion from TreeMap[A, B] to StringFormat[TreeMap[A, B]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

63. #### def from(from: A): TreeMap[A, B]

    Creates a ranged projection of this collection with no upper-bound.

    Creates a ranged projection of this collection with no upper-bound.

    from

      The lower-bound (inclusive) of the ranged projection.

    Definition Classes
      TreeMap → Sorted

64. #### def genericBuilder[B]: Builder[B, Iterable[B]]

    The generic builder that builds instances of Traversable at arbitrary element types.

    The generic builder that builds instances of Traversable at arbitrary element types.

    Definition Classes
      GenericTraversableTemplate

65. #### def get(key: A): Option[B]

    Check if this map maps `key` to a value and return the value if it exists.

    Check if this map maps `key` to a value and return the value if it exists.

    key

      the key of the mapping of interest

    returns

      the value of the mapping, if it exists

    Definition Classes
      TreeMap → MapLike → GenMapLike

66. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

67. #### def getOrElse(key: A, default: ⇒ B): B

    [use case] Returns the value associated with a key, or a default value if the key is not contained in the map.

    [use case]

    Returns the value associated with a key, or a default value if the key is not contained in the map.

    key

      the key.

    default

      a computation that yields a default value in case no binding for `key` is found in the map.

    returns

      the value associated with `key` if it exists, otherwise the result of the `default` computation.

    Definition Classes
      MapLike → GenMapLike
    Full Signature

    #### def getOrElse[B1 >: B](key: A, default: ⇒ B1): B1

68. #### def groupBy[K](f: ((A, B)) ⇒ K): Map[K, TreeMap[A, B]]

    Partitions this traversable collection into a map of traversable collections according to some discriminator function.

    Partitions this traversable collection into a map of traversable collections according to some discriminator function.

    Note: this method is not re-implemented by views. This means when applied to a view it will always force the view and return a new traversable collection.

    K

      the type of keys returned by the discriminator function.

    f

      the discriminator function.

    returns

      A map from keys to traversable collections such that the following invariant holds:

          (xs groupBy f)(k) = xs filter (x => f(x) == k)

      That is, every key `k` is bound to a traversable collection of those elements `x` for which `f(x)` equals `k`.

    Definition Classes
      TraversableLike → GenTraversableLike

69. #### def grouped(size: Int): Iterator[TreeMap[A, B]]

    Partitions elements in fixed size iterable collections.

    Partitions elements in fixed size iterable collections.

    size

      the number of elements per group

    returns

      An iterator producing iterable collections of size `size`, except the last will be less than size `size` if the elements don't divide evenly.

    Definition Classes
      IterableLike
    See also

      scala.collection.Iterator, method `grouped`

70. #### def hasAll(j: Iterator[A]): Boolean

    Attributes
      protected
    Definition Classes
      Sorted

71. #### def hasDefiniteSize: Boolean

    Tests whether this traversable collection is known to have a finite size.

    Tests whether this traversable collection is known to have a finite size. All strict collections are known to have finite size. For a non-strict collection such as `Stream`, the predicate returns `true` if all elements have been computed. It returns `false` if the stream is not yet evaluated to the end.

    Note: many collection methods will not work on collections of infinite sizes.

    returns

      `true` if this collection is known to have finite size, `false` otherwise.

    Definition Classes
      TraversableLike → TraversableOnce → GenTraversableOnce

72. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      GenMapLike → AnyRef → Any

73. #### def head: (A, B)

    Selects the first element of this immutable tree map.

    Selects the first element of this immutable tree map.

    returns

      the first element of this immutable tree map.

    Definition Classes
      TreeMap → IterableLike → GenericTraversableTemplate → TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` if the immutable tree map is empty.

74. #### def headOption: Option[(A, B)]

    Optionally selects the first element.

    Optionally selects the first element.

    returns

      the first element of this immutable tree map if it is nonempty, `None` if it is empty.

    Definition Classes
      TreeMap → TraversableLike → GenTraversableLike

75. #### def init: TreeMap[A, B]

    Selects all elements except the last.

    Selects all elements except the last.

    returns

      a immutable tree map consisting of all elements of this immutable tree map except the last one.

    Definition Classes
      TreeMap → TraversableLike → GenTraversableLike
    Exceptions thrown

      `UnsupportedOperationException` if the immutable tree map is empty.

76. #### def inits: Iterator[TreeMap[A, B]]

    Iterates over the inits of this traversable collection.

    Iterates over the inits of this traversable collection. The first value will be this traversable collection and the final one will be an empty traversable collection, with the intervening values the results of successive applications of `init`.

    returns

      an iterator over all the inits of this traversable collection

    Definition Classes
      TraversableLike
    Example:

    1. `List(1,2,3).inits = Iterator(List(1,2,3), List(1,2), List(1), Nil)`

77. #### def insert[B1 >: B](key: A, value: B1): TreeMap[A, B1]

    A new TreeMap with the entry added is returned, assuming that key is not in the TreeMap.

    A new TreeMap with the entry added is returned, assuming that key is not in the TreeMap.

    B1

      type of the values of the new bindings, a supertype of `B`

    key

      the key to be inserted

    value

      the value to be associated with `key`

    returns

      a new immutable tree map with the inserted binding, if it wasn't present in the map

78. #### def isDefinedAt(key: A): Boolean

    Tests whether this map contains a binding for a key.

    Tests whether this map contains a binding for a key. This method, which implements an abstract method of trait `PartialFunction`, is equivalent to `contains`.

    key

      the key

    returns

      `true` if there is a binding for `key` in this map, `false` otherwise.

    Definition Classes
      TreeMap → MapLike → PartialFunction → GenMapLike

79. #### def isEmpty: Boolean

    Tests whether the map is empty.

    Tests whether the map is empty.

    returns

      `true` if the map does not contain any key/value binding, `false` otherwise.

    Definition Classes
      MapLike → IterableLike → TraversableLike → TraversableOnce → GenTraversableOnce

80. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

81. #### final def isTraversableAgain: Boolean

    Tests whether this traversable collection can be repeatedly traversed.

    Tests whether this traversable collection can be repeatedly traversed.

    returns

      `true`

    Definition Classes
      TraversableLike → GenTraversableLike → GenTraversableOnce

82. #### def iterator: Iterator[(A, B)]

    Creates a new iterator over all elements contained in this object.

    Creates a new iterator over all elements contained in this object.

    returns

      the new iterator

    Definition Classes
      TreeMap → MapLike → IterableLike → GenIterableLike

83. #### def iteratorFrom(start: A): Iterator[(A, B)]

    Creates an iterator over all the key/value pairs contained in this map having a key greater than or equal to `start` according to the ordering of this map.

    Creates an iterator over all the key/value pairs contained in this map having a key greater than or equal to `start` according to the ordering of this map. x.iteratorFrom(y) is equivalent to but often more efficient than x.from(y).iterator.

    start

      The lower bound (inclusive) on the keys to be returned

    Definition Classes
      TreeMap → SortedMapLike

84. #### def keySet: SortedSet[A]

    Collects all keys of this map in a set.

    Collects all keys of this map in a set.

    returns

      a set containing all keys of this map.

    Definition Classes
      SortedMap → SortedMapLike → Sorted → MapLike → MapLike → GenMapLike

85. #### def keys: collection.Iterable[A]

    Collects all keys of this map in an iterable collection.

    Collects all keys of this map in an iterable collection.

    returns

      the keys of this map as an iterable.

    Definition Classes
      MapLike → GenMapLike
    Annotations
      @migration
    Migration

      (Changed in version 2.8.0) `keys` returns `Iterable[A]` rather than `Iterator[A]`.

86. #### def keysIterator: Iterator[A]

    Creates an iterator for all keys.

    Creates an iterator for all keys.

    returns

      an iterator over all keys.

    Definition Classes
      TreeMap → MapLike → GenMapLike

87. #### def keysIteratorFrom(start: A): Iterator[A]

    Creates an iterator over all the keys(or elements) contained in this collection greater than or equal to `start` according to the ordering of this collection.

    Creates an iterator over all the keys(or elements) contained in this collection greater than or equal to `start` according to the ordering of this collection. x.keysIteratorFrom(y) is equivalent to but often more efficient than x.from(y).keysIterator.

    start

      The lower bound (inclusive) on the keys to be returned

    Definition Classes
      TreeMap → Sorted

88. #### def last: (A, B)

    Selects the last element.

    Selects the last element.

    returns

      The last element of this immutable tree map.

    Definition Classes
      TreeMap → TraversableLike → GenTraversableLike
    Exceptions thrown

      `NoSuchElementException` If the immutable tree map is empty.

89. #### def lastKey: A

    Returns the last key of the collection.

    Returns the last key of the collection.

    Definition Classes
      TreeMap → SortedMapLike → Sorted

90. #### def lastOption: Option[(A, B)]

    Optionally selects the last element.

    Optionally selects the last element.

    returns

      the last element of this immutable tree map$ if it is nonempty, `None` if it is empty.

    Definition Classes
      TreeMap → TraversableLike → GenTraversableLike

91. #### def lift: (A) ⇒ Option[B]

    Turns this partial function into a plain function returning an `Option` result.

    Turns this partial function into a plain function returning an `Option` result.

    returns

      a function that takes an argument `x` to `Some(this(x))` if `this` is defined for `x`, and to `None` otherwise.

    Definition Classes
      PartialFunction
    See also

      Function.unlift

92. #### def map[B](f: (A) ⇒ B): TreeMap[B]

    [use case] Builds a new collection by applying a function to all elements of this immutable tree map.

    [use case]

    Builds a new collection by applying a function to all elements of this immutable tree map.

    B

      the element type of the returned collection.

    f

      the function to apply to each element.

    returns

      a new immutable tree map resulting from applying the given function `f` to each element of this immutable tree map and collecting the results.

    Definition Classes
      TraversableLike → GenTraversableLike → FilterMonadic
    Full Signature

    #### def map[B, That](f: ((A, B)) ⇒ B)(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

93. #### def mapValues[C](f: (B) ⇒ C): SortedMap[A, C]

    Transforms this map by applying a function to every retrieved value.

    Transforms this map by applying a function to every retrieved value.

    f

      the function used to transform values of this map.

    returns

      a map view which maps every key of this map to `f(this(key))`. The resulting map wraps the original map without copying any elements.

    Definition Classes
      SortedMap → SortedMapLike → MapLike → MapLike → GenMapLike

94. #### def max: A

    [use case] Finds the largest element.

    [use case]

    Finds the largest element.

    returns

      the largest element of this immutable tree map.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def max[B >: (A, B)](implicit cmp: Ordering[B]): (A, B)

95. #### def maxBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the largest value measured by function f.

    [use case]

    Finds the first element which yields the largest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this immutable tree map with the largest value measured by function f.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def maxBy[B](f: ((A, B)) ⇒ B)(implicit cmp: Ordering[B]): (A, B)

96. #### def min: A

    [use case] Finds the smallest element.

    [use case]

    Finds the smallest element.

    returns

      the smallest element of this immutable tree map

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def min[B >: (A, B)](implicit cmp: Ordering[B]): (A, B)

97. #### def minBy[B](f: (A) ⇒ B): A

    [use case] Finds the first element which yields the smallest value measured by function f.

    [use case]

    Finds the first element which yields the smallest value measured by function f.

    B

      The result type of the function f.

    f

      The measuring function.

    returns

      the first element of this immutable tree map with the smallest value measured by function f.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Full Signature

    #### def minBy[B](f: ((A, B)) ⇒ B)(implicit cmp: Ordering[B]): (A, B)

98. #### def mkString: String

    Displays all elements of this traversable or iterator in a string.

    Displays all elements of this traversable or iterator in a string.

    returns

      a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator follow each other without any separator string.

    Definition Classes
      TraversableOnce → GenTraversableOnce

99. #### def mkString(sep: String): String

    Displays all elements of this traversable or iterator in a string using a separator string.

    Displays all elements of this traversable or iterator in a string using a separator string.

    sep

      the separator string.

    returns

      a string representation of this traversable or iterator. In the resulting string the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

    Definition Classes
      TraversableOnce → GenTraversableOnce
    Example:

    1. `List(1, 2, 3).mkString("|") = "1|2|3"`

100. #### def mkString(start: String, sep: String, end: String): String

     Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

     Displays all elements of this traversable or iterator in a string using start, end, and separator strings.

     start

       the starting string.

     sep

       the separator string.

     end

       the ending string.

     returns

       a string representation of this traversable or iterator. The resulting string begins with the string `start` and ends with the string `end`. Inside, the string representations (w.r.t. the method `toString`) of all elements of this traversable or iterator are separated by the string `sep`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Example:

     1. `List(1, 2, 3).mkString("(", "; ", ")") = "(1; 2; 3)"`

101. #### final def ne(arg0: AnyRef): Boolean

     Equivalent to `!(this eq that)`.

     Equivalent to `!(this eq that)`.

     returns

       `true` if the argument is not a reference to the receiver object; `false` otherwise.

     Definition Classes
       AnyRef

102. #### def newBuilder: Builder[(A, B), TreeMap[A, B]]

     A common implementation of `newBuilder` for all maps in terms of `empty`.

     A common implementation of `newBuilder` for all maps in terms of `empty`. Overridden for mutable maps in `mutable.MapLike`.

     Attributes
       protected[this]
     Definition Classes
       TreeMap → SortedMap → SortedMap → MapLike → GenericTraversableTemplate → TraversableLike → HasNewBuilder

103. #### def nonEmpty: Boolean

     Tests whether the traversable or iterator is not empty.

     Tests whether the traversable or iterator is not empty.

     returns

       `true` if the traversable or iterator contains at least one element, `false` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

104. #### final def notify(): Unit

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Wakes up a single thread that is waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

105. #### final def notifyAll(): Unit

     Wakes up all threads that are waiting on the receiver object's monitor.

     Wakes up all threads that are waiting on the receiver object's monitor.

     Definition Classes
       AnyRef
     Note

       not specified by SLS as a member of AnyRef

106. #### def orElse[A1 <: A, B1 >: B](that: PartialFunction[A1, B1]): PartialFunction[A1, B1]

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     Composes this partial function with a fallback partial function which gets applied where this partial function is not defined.

     A1

       the argument type of the fallback function

     B1

       the result type of the fallback function

     that

       the fallback function

     returns

       a partial function which has as domain the union of the domains of this partial function and `that`. The resulting partial function takes `x` to `this(x)` where `this` is defined, and to `that(x)` where it is not.

     Definition Classes
       PartialFunction

107. #### implicit val ordering: Ordering[A]

     the implicit ordering used to compare objects of type `A`.

     the implicit ordering used to compare objects of type `A`.

     Definition Classes
       TreeMap → SortedMapLike → Sorted

108. #### def par: ParMap[A, B]

     Returns a parallel implementation of this collection.

     Returns a parallel implementation of this collection.

     For most collection types, this method creates a new parallel collection by copying all the elements. For these collection, `par` takes linear time. Mutable collections in this category do not produce a mutable parallel collection that has the same underlying dataset, so changes in one collection will not be reflected in the other one.

     Specific collections (e.g. `ParArray` or `mutable.ParHashMap`) override this default behaviour by creating a parallel collection which shares the same underlying dataset. For these collections, `par` takes constant or sublinear time.

     All parallel collections return a reference to themselves.

     returns

       a parallel implementation of this collection

     Definition Classes
       Parallelizable

109. #### def parCombiner: Combiner[(A, B), ParMap[A, B]]

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     The default `par` implementation uses the combiner provided by this method to create a new parallel collection.

     returns

       a combiner for the parallel collection of type `ParRepr`

     Attributes
       protected[this]
     Definition Classes
       MapLike → MapLike → TraversableLike → Parallelizable

110. #### def partition(p: ((A, B)) ⇒ Boolean): (TreeMap[A, B], TreeMap[A, B])

     Partitions this traversable collection in two traversable collections according to a predicate.

     Partitions this traversable collection in two traversable collections according to a predicate.

     p

       the predicate on which to partition.

     returns

       a pair of traversable collections: the first traversable collection consists of all elements that satisfy the predicate `p` and the second traversable collection consists of all elements that don't. The relative order of the elements in the resulting traversable collections is the same as in the original traversable collection.

     Definition Classes
       TraversableLike → GenTraversableLike

111. #### def product: A

     [use case] Multiplies up the elements of this collection.

     [use case]

     Multiplies up the elements of this collection.

     returns

       the product of all elements in this immutable tree map of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the immutable tree map and as result type of `product`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def product[B >: (A, B)](implicit num: Numeric[B]): B

112. #### def range(from: A, until: A): TreeMap[A, B]

     Creates a ranged projection of this collection with both a lower-bound and an upper-bound.

     Creates a ranged projection of this collection with both a lower-bound and an upper-bound.

     from

       The lower-bound (inclusive) of the ranged projection.

     until

       The upper-bound (exclusive) of the ranged projection.

     Definition Classes
       TreeMap → Sorted

113. #### def rangeImpl(from: Option[A], until: Option[A]): TreeMap[A, B]

     Creates a ranged projection of this collection.

     Creates a ranged projection of this collection. Any mutations in the ranged projection will update this collection and vice versa.

     Note: keys are not garuanteed to be consistent between this collection and the projection. This is the case for buffers where indexing is relative to the projection.

     from

       The lower-bound (inclusive) of the ranged projection. `None` if there is no lower bound.

     until

       The upper-bound (exclusive) of the ranged projection. `None` if there is no upper bound.

     Definition Classes
       TreeMap → SortedMapLike → Sorted

114. #### def reduce[A1 >: (A, B)](op: (A1, A1) ⇒ A1): A1

     Reduces the elements of this traversable or iterator using the specified associative binary operator.

     Reduces the elements of this traversable or iterator using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       The result of applying reduce operator `op` between all the elements if the traversable or iterator is nonempty.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this traversable or iterator is empty.

115. #### def reduceLeft[B >: (A, B)](op: (B, (A, B)) ⇒ B): B

     Applies a binary operator to all elements of this traversable or iterator, going left to right.

     Applies a binary operator to all elements of this traversable or iterator, going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this traversable or iterator, going left to right:

           op( op( ... op(x_1, x_2) ..., x_{n-1}), x_n)

       where `x1, ..., xn` are the elements of this traversable or iterator.

     Definition Classes
       TraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this traversable or iterator is empty.

116. #### def reduceLeftOption[B >: (A, B)](op: (B, (A, B)) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

     Optionally applies a binary operator to all elements of this traversable or iterator, going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceLeft(op)` is this traversable or iterator is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

117. #### def reduceOption[A1 >: (A, B)](op: (A1, A1) ⇒ A1): Option[A1]

     Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

     Reduces the elements of this traversable or iterator, if any, using the specified associative binary operator.

     The order in which operations are performed on elements is unspecified and may be nondeterministic.

     A1

       A type parameter for the binary operator, a supertype of `A`.

     op

       A binary operator that must be associative.

     returns

       An option value containing result of applying reduce operator `op` between all the elements if the collection is nonempty, and `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

118. #### def reduceRight[B >: (A, B)](op: ((A, B), B) ⇒ B): B

     Applies a binary operator to all elements of this iterable collection, going right to left.

     Applies a binary operator to all elements of this iterable collection, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered. or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       the result of inserting `op` between consecutive elements of this iterable collection, going right to left:

           op(x_1, op(x_2, ..., op(x_{n-1}, x_n)...))

       where `x1, ..., xn` are the elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce
     Exceptions thrown

       `UnsupportedOperationException` if this iterable collection is empty.

119. #### def reduceRightOption[B >: (A, B)](op: ((A, B), B) ⇒ B): Option[B]

     Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

     Optionally applies a binary operator to all elements of this traversable or iterator, going right to left.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered or the operator is associative and commutative.

     B

       the result type of the binary operator.

     op

       the binary operator.

     returns

       an option value containing the result of `reduceRight(op)` is this traversable or iterator is nonempty, `None` otherwise.

     Definition Classes
       TraversableOnce → GenTraversableOnce

120. #### def repr: TreeMap[A, B]

     The collection of type traversable collection underlying this `TraversableLike` object.

     The collection of type traversable collection underlying this `TraversableLike` object. By default this is implemented as the `TraversableLike` object itself, but this can be overridden.

     Definition Classes
       TraversableLike → GenTraversableLike

121. #### def reversed: scala.List[(A, B)]

     Attributes
       protected[this]
     Definition Classes
       TraversableOnce

122. #### def runWith[U](action: (B) ⇒ U): (A) ⇒ Boolean

     Composes this partial function with an action function which gets applied to results of this partial function.

     Composes this partial function with an action function which gets applied to results of this partial function. The action function is invoked only for its side effects; its result is ignored.

     Note that expression `pf.runWith(action)(x)` is equivalent to

         if(pf isDefinedAt x) { action(pf(x)); true } else false

     except that `runWith` is implemented via `applyOrElse` and thus potentially more efficient. Using `runWith` avoids double evaluation of pattern matchers and guards for partial function literals.

     action

       the action function

     returns

       a function which maps arguments `x` to `isDefinedAt(x)`. The resulting function runs `action(this(x))` where `this` is defined.

     Definition Classes
       PartialFunction
     Since

       2.10

     See also

       `applyOrElse`.

123. #### def sameElements(that: GenIterable[A]): Boolean

     [use case] Checks if the other iterable collection contains the same elements in the same order as this immutable tree map.

     [use case]

     Checks if the other iterable collection contains the same elements in the same order as this immutable tree map.

     that

       the collection to compare with.

     returns

       `true`, if both collections contain the same elements in the same order, `false` otherwise.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def sameElements[B >: (A, B)](that: GenIterable[B]): Boolean

124. #### def scan[B >: (A, B), That](z: B)(op: (B, B) ⇒ B)(implicit cbf: CanBuildFrom[TreeMap[A, B], B, That]): That

     Computes a prefix scan of the elements of the collection.

     Computes a prefix scan of the elements of the collection.

     Note: The neutral element `z` may be applied more than once.

     B

       element type of the resulting collection

     That

       type of the resulting collection

     z

       neutral element for the operator `op`

     op

       the associative operator for the scan

     cbf

       combiner factory which provides a combiner

     returns

       a new traversable collection containing the prefix scan of the elements in this traversable collection

     Definition Classes
       TraversableLike → GenTraversableLike

125. #### def scanLeft[B, That](z: B)(op: (B, (A, B)) ⇒ B)(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

     Produces a collection containing cumulative results of applying the operator going left to right.

     Produces a collection containing cumulative results of applying the operator going left to right.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike

126. #### def scanRight[B, That](z: B)(op: ((A, B), B) ⇒ B)(implicit bf: CanBuildFrom[TreeMap[A, B], B, That]): That

     Produces a collection containing cumulative results of applying the operator going right to left.

     Produces a collection containing cumulative results of applying the operator going right to left. The head of the collection is the last cumulative result.

     Note: will not terminate for infinite-sized collections.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     Example:

         List(1, 2, 3, 4).scanRight(0)(_ + _) == List(10, 9, 7, 4, 0)

     B

       the type of the elements in the resulting collection

     That

       the actual type of the resulting collection

     z

       the initial value

     op

       the binary operator applied to the intermediate result and the element

     bf

       an implicit value of class `CanBuildFrom` which determines the result class `That` from the current representation type `Repr` and and the new element type `B`.

     returns

       collection with intermediate results

     Definition Classes
       TraversableLike → GenTraversableLike
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) The behavior of `scanRight` has changed. The previous behavior can be reproduced with scanRight.reverse.

127. #### def seq: Map[A, B]

     A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

     A version of this collection with all of the operations implemented sequentially (i.e., in a single-threaded manner).

     This method returns a reference to this collection. In parallel collections, it is redefined to return a sequential implementation of this collection. In both cases, it has O(1) complexity.

     returns

       a sequential view of the collection.

     Definition Classes
       Map → Map → GenMap → GenMapLike → Iterable → Iterable → GenIterable → Traversable → Traversable → GenTraversable → Parallelizable → TraversableOnce → GenTraversableOnce

128. #### def size: Int

     The size of this immutable tree map.

     The size of this immutable tree map.

     returns

       the number of elements in this immutable tree map.

     Definition Classes
       TreeMap → GenTraversableLike → TraversableOnce → GenTraversableOnce

129. #### def slice(from: Int, until: Int): TreeMap[A, B]

     Selects an interval of elements.

     Selects an interval of elements. The returned collection is made up of all elements `x` which satisfy the invariant:

         from <= indexOf(x) < until

     returns

       a immutable tree map containing the elements greater than or equal to index `from` extending up to (but not including) index `until` of this immutable tree map.

     Definition Classes
       TreeMap → IterableLike → TraversableLike → GenTraversableLike

130. #### def sliding(size: Int, step: Int): Iterator[TreeMap[A, B]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.)

     size

       the number of elements per group

     step

       the distance between the first elements of successive groups

     returns

       An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

131. #### def sliding(size: Int): Iterator[TreeMap[A, B]]

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

     Groups elements in fixed size blocks by passing a "sliding window" over them (as opposed to partitioning them, as is done in grouped.) "Sliding window" step is 1 by default.

     size

       the number of elements per group

     returns

       An iterator producing iterable collections of size `size`, except the last and the only element will be truncated if there are fewer elements than size.

     Definition Classes
       IterableLike
     See also

       scala.collection.Iterator, method `sliding`

132. #### def span(p: ((A, B)) ⇒ Boolean): (TreeMap[A, B], TreeMap[A, B])

     Splits this immutable tree map into a prefix/suffix pair according to a predicate.

     Splits this immutable tree map into a prefix/suffix pair according to a predicate.

     Note: `c span p` is equivalent to (but possibly more efficient than) `(c takeWhile p, c dropWhile p)`, provided the evaluation of the predicate `p` does not cause any side-effects.

     returns

       a pair consisting of the longest prefix of this immutable tree map whose elements all satisfy `p`, and the rest of this immutable tree map.

     Definition Classes
       TreeMap → TraversableLike → GenTraversableLike

133. #### def splitAt(n: Int): (TreeMap[A, B], TreeMap[A, B])

     Splits this immutable tree map into two at a given position.

     Splits this immutable tree map into two at a given position. Note: `c splitAt n` is equivalent to (but possibly more efficient than) `(c take n, c drop n)`.

     n

       the position at which to split.

     returns

       a pair of immutable tree maps consisting of the first `n` elements of this immutable tree map, and the other elements.

     Definition Classes
       TreeMap → TraversableLike → GenTraversableLike

134. #### def stringPrefix: String

     Defines the prefix of this object's `toString` representation.

     Defines the prefix of this object's `toString` representation.

     returns

       a string representation which starts the result of `toString` applied to this map. Unless overridden in subclasses, the string prefix of every map is `"Map"`.

     Definition Classes
       MapLike → TraversableLike → GenTraversableLike

135. #### def sum: A

     [use case] Sums up the elements of this collection.

     [use case]

     Sums up the elements of this collection.

     returns

       the sum of all elements in this immutable tree map of numbers of type `Int`. Instead of `Int`, any other type `T` with an implicit `Numeric[T]` implementation can be used as element type of the immutable tree map and as result type of `sum`. Examples of such types are: `Long`, `Float`, `Double`, `BigInt`.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def sum[B >: (A, B)](implicit num: Numeric[B]): B

136. #### final def synchronized[T0](arg0: ⇒ T0): T0

     Definition Classes
       AnyRef

137. #### def tail: TreeMap[A, B]

     Selects all elements except the first.

     Selects all elements except the first.

     returns

       a immutable tree map consisting of all elements of this immutable tree map except the first one.

     Definition Classes
       TreeMap → TraversableLike → GenTraversableLike
     Exceptions thrown

       ``UnsupportedOperationException`` if the immutable tree map is empty.

138. #### def tails: Iterator[TreeMap[A, B]]

     Iterates over the tails of this traversable collection.

     Iterates over the tails of this traversable collection. The first value will be this traversable collection and the final one will be an empty traversable collection, with the intervening values the results of successive applications of `tail`.

     returns

       an iterator over all the tails of this traversable collection

     Definition Classes
       TraversableLike
     Example:

     1. `List(1,2,3).tails = Iterator(List(1,2,3), List(2,3), List(3), Nil)`

139. #### def take(n: Int): TreeMap[A, B]

     Selects first n elements.

     Selects first n elements.

     n

       the number of elements to take from this immutable tree map.

     returns

       a immutable tree map consisting only of the first `n` elements of this immutable tree map, or else the whole immutable tree map, if it has less than `n` elements.

     Definition Classes
       TreeMap → IterableLike → TraversableLike → GenTraversableLike

140. #### def takeRight(n: Int): TreeMap[A, B]

     Selects last n elements.

     Selects last n elements.

     n

       the number of elements to take

     returns

       a immutable tree map consisting only of the last `n` elements of this immutable tree map, or else the whole immutable tree map, if it has less than `n` elements.

     Definition Classes
       TreeMap → IterableLike

141. #### def takeWhile(p: ((A, B)) ⇒ Boolean): TreeMap[A, B]

     Takes longest prefix of elements that satisfy a predicate.

     Takes longest prefix of elements that satisfy a predicate.

     returns

       the longest prefix of this immutable tree map whose elements all satisfy the predicate `p`.

     Definition Classes
       TreeMap → IterableLike → TraversableLike → GenTraversableLike

142. #### def thisCollection: collection.Iterable[(A, B)]

     The underlying collection seen as an instance of `Iterable`.

     The underlying collection seen as an instance of `Iterable`. By default this is implemented as the current collection object itself, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

143. #### def to(to: A): TreeMap[A, B]

     Create a range projection of this collection with no lower-bound.

     Create a range projection of this collection with no lower-bound.

     to

       The upper-bound (inclusive) of the ranged projection.

     Definition Classes
       TreeMap → Sorted

144. #### def to[Col[_]]: Col[A]

     [use case] Converts this immutable tree map into another by copying all elements.

     [use case]

     Converts this immutable tree map into another by copying all elements.

     Col

       The collection type to build.

     returns

       a new collection containing all elements of this immutable tree map.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Full Signature

     #### def to[Col[_]](implicit cbf: CanBuildFrom[Nothing, (A, B), Col[(A, B)]]): Col[(A, B)]

145. #### def toArray: Array[A]

     [use case] Converts this immutable tree map to an array.

     [use case]

     Converts this immutable tree map to an array.

     returns

       an array containing all elements of this immutable tree map. An `ClassTag` must be available for the element type of this immutable tree map.

     Definition Classes
       TraversableOnce → GenTraversableOnce
     Full Signature

     #### def toArray[B >: (A, B)](implicit arg0: ClassTag[B]): Array[B]

146. #### def toBuffer[C >: (A, B)]: Buffer[C]

     Uses the contents of this map to create a new mutable buffer.

     Uses the contents of this map to create a new mutable buffer.

     returns

       a buffer containing all elements of this map.

     Definition Classes
       MapLike → TraversableOnce → GenTraversableOnce

147. #### def toCollection(repr: TreeMap[A, B]): collection.Iterable[(A, B)]

     A conversion from collections of type `Repr` to `Iterable` objects.

     A conversion from collections of type `Repr` to `Iterable` objects. By default this is implemented as just a cast, but this can be overridden.

     Attributes
       protected[this]
     Definition Classes
       IterableLike → TraversableLike

148. #### def toIndexedSeq: IndexedSeq[(A, B)]

     Converts this traversable or iterator to an indexed sequence.

     Converts this traversable or iterator to an indexed sequence.

     Note: will not terminate for infinite-sized collections.

     returns

       an indexed sequence containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

149. #### def toIterable: collection.Iterable[(A, B)]

     Returns this iterable collection as an iterable collection.

     Returns this iterable collection as an iterable collection.

     A new collection will not be built; lazy collections will stay lazy.

     Note: will not terminate for infinite-sized collections.

     returns

       an `Iterable` containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableOnce → GenTraversableOnce

150. #### def toIterator: Iterator[(A, B)]

     Returns an Iterator over the elements in this iterable collection.

     Returns an Iterator over the elements in this iterable collection. Produces the same result as `iterator`.

     Note: will not terminate for infinite-sized collections.

     returns

       an Iterator containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

151. #### def toList: scala.List[(A, B)]

     Converts this traversable or iterator to a list.

     Converts this traversable or iterator to a list.

     Note: will not terminate for infinite-sized collections.

     returns

       a list containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

152. #### def toMap[T, U](implicit ev: <:<[(A, B), (T, U)]): Map[T, U]

     Returns this immutable map as an immutable map.

     Returns this immutable map as an immutable map.

     A new map will not be built; lazy collections will stay lazy.

     returns

       a map containing all elements of this immutable map.

     Definition Classes
       Map → TraversableOnce → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

153. #### def toParArray: ParArray[T]

     Implicit information
       This member is added by an implicit conversion from TreeMap[A, B] to CollectionsHaveToParArray[TreeMap[A, B], T] performed by method CollectionsHaveToParArray in scala.collection.parallel. This conversion will take place only if an implicit value of type (TreeMap[A, B]) ⇒ GenTraversableOnce[T] is in scope.
     Definition Classes
       CollectionsHaveToParArray

154. #### def toSeq: collection.Seq[(A, B)]

     Converts this map to a sequence.

     Converts this map to a sequence. As with `toIterable`, it's lazy in this default implementation, as this `TraversableOnce` may be lazy and unevaluated.

     returns

       a sequence containing all elements of this map.

     Definition Classes
       MapLike → TraversableOnce → GenTraversableOnce

155. #### def toSet[B >: (A, B)]: Set[B]

     Converts this traversable or iterator to a set.

     Converts this traversable or iterator to a set.

     Note: will not terminate for infinite-sized collections.

     returns

       a set containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

156. #### def toStream: Stream[(A, B)]

     Converts this iterable collection to a stream.

     Converts this iterable collection to a stream.

     returns

       a stream containing all elements of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike → GenTraversableOnce

157. #### def toString(): String

     Converts this map to a string.

     Converts this map to a string.

     returns

       a string representation of this collection. By default this string consists of the `stringPrefix` of this map, followed by all elements separated by commas and enclosed in parentheses.

     Definition Classes
       MapLike → TraversableLike → Function1 → AnyRef → Any

158. #### def toTraversable: collection.Traversable[(A, B)]

     Converts this traversable collection to an unspecified Traversable.

     Converts this traversable collection to an unspecified Traversable. Will return the same collection if this instance is already Traversable.

     Note: will not terminate for infinite-sized collections.

     returns

       a Traversable containing all elements of this traversable collection.

     Definition Classes
       TraversableLike → TraversableOnce → GenTraversableOnce
     Annotations
       @deprecatedOverriding( ... , "2.11.0" )

159. #### def toVector: scala.Vector[(A, B)]

     Converts this traversable or iterator to a Vector.

     Converts this traversable or iterator to a Vector.

     Note: will not terminate for infinite-sized collections.

     returns

       a vector containing all elements of this traversable or iterator.

     Definition Classes
       TraversableOnce → GenTraversableOnce

160. #### def transform[C, That](f: (A, B) ⇒ C)(implicit bf: CanBuildFrom[TreeMap[A, B], (A, C), That]): That

     This function transforms all the values of mappings contained in this map with function `f`.

     This function transforms all the values of mappings contained in this map with function `f`.

     f

       A function over keys and values

     returns

       the updated map

     Definition Classes
       MapLike

161. #### def transpose[B](implicit asTraversable: ((A, B)) ⇒ GenTraversableOnce[B]): Iterable[Iterable[B]]

     Transposes this collection of traversable collections into a collection of collections.

     Transposes this collection of traversable collections into a collection of collections.

     The resulting collection's type will be guided by the static type of collection. For example:

         val xs = List(
                    Set(1, 2, 3),
                    Set(4, 5, 6)).transpose
         // xs == List(
         //         List(1, 4),
         //         List(2, 5),
         //         List(3, 6))

         val ys = Vector(
                    List(1, 2, 3),
                    List(4, 5, 6)).transpose
         // ys == Vector(
         //         Vector(1, 4),
         //         Vector(2, 5),
         //         Vector(3, 6))

     B

       the type of the elements of each traversable collection.

     asTraversable

       an implicit conversion which asserts that the element type of this collection is a `Traversable`.

     returns

       a two-dimensional collection of collections which has as nth row the nth column of this collection.

     Definition Classes
       GenericTraversableTemplate
     Annotations
       @migration
     Migration

       (Changed in version 2.9.0) `transpose` throws an `IllegalArgumentException` if collections are not uniformly sized.

     Exceptions thrown

       `IllegalArgumentException` if all collections in this collection are not of the same size.

162. #### def until(until: A): TreeMap[A, B]

     Creates a ranged projection of this collection with no lower-bound.

     Creates a ranged projection of this collection with no lower-bound.

     until

       The upper-bound (exclusive) of the ranged projection.

     Definition Classes
       TreeMap → Sorted

163. #### def unzip[A1, A2](implicit asPair: ((A, B)) ⇒ (A1, A2)): (Iterable[A1], Iterable[A2])

     Converts this collection of pairs into two collections of the first and second half of each pair.

     Converts this collection of pairs into two collections of the first and second half of each pair.

         val xs = Traversable(
                    (1, "one"),
                    (2, "two"),
                    (3, "three")).unzip
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three))

     A1

       the type of the first half of the element pairs

     A2

       the type of the second half of the element pairs

     asPair

       an implicit conversion which asserts that the element type of this collection is a pair.

     returns

       a pair of collections, containing the first, respectively second half of each element pair of this collection.

     Definition Classes
       GenericTraversableTemplate

164. #### def unzip3[A1, A2, A3](implicit asTriple: ((A, B)) ⇒ (A1, A2, A3)): (Iterable[A1], Iterable[A2], Iterable[A3])

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

     Converts this collection of triples into three collections of the first, second, and third element of each triple.

         val xs = Traversable(
                    (1, "one", '1'),
                    (2, "two", '2'),
                    (3, "three", '3')).unzip3
         // xs == (Traversable(1, 2, 3),
         //        Traversable(one, two, three),
         //        Traversable(1, 2, 3))

     A1

       the type of the first member of the element triples

     A2

       the type of the second member of the element triples

     A3

       the type of the third member of the element triples

     asTriple

       an implicit conversion which asserts that the element type of this collection is a triple.

     returns

       a triple of collections, containing the first, second, respectively third member of each element triple of this collection.

     Definition Classes
       GenericTraversableTemplate

165. #### def updated[B1 >: B](key: A, value: B1): TreeMap[A, B1]

     A new TreeMap with the entry added is returned, if key is not in the TreeMap, otherwise the key is updated with the new entry.

     A new TreeMap with the entry added is returned, if key is not in the TreeMap, otherwise the key is updated with the new entry.

     B1

       type of the value of the new binding which is a supertype of `B`

     key

       the key that should be updated

     value

       the value to be associated with `key`

     returns

       a new immutable tree map with the updated binding

     Definition Classes
       TreeMap → SortedMap → SortedMapLike → Map → MapLike → MapLike → GenMap

166. #### def values: collection.Iterable[B]

     Collects all values of this map in an iterable collection.

     Collects all values of this map in an iterable collection.

     returns

       the values of this map as an iterable.

     Definition Classes
       MapLike → GenMapLike
     Annotations
       @migration
     Migration

       (Changed in version 2.8.0) `values` returns `Iterable[B]` rather than `Iterator[B]`.

167. #### def valuesIterator: Iterator[B]

     Creates an iterator for all values in this map.

     Creates an iterator for all values in this map.

     returns

       an iterator over all values that are associated with some key in this map.

     Definition Classes
       TreeMap → MapLike → GenMapLike

168. #### def valuesIteratorFrom(start: A): Iterator[B]

     Creates an iterator over all the values contained in this map that are associated with a key greater than or equal to `start` according to the ordering of this map.

     Creates an iterator over all the values contained in this map that are associated with a key greater than or equal to `start` according to the ordering of this map. x.valuesIteratorFrom(y) is equivalent to but often more efficient than x.from(y).valuesIterator.

     start

       The lower bound (inclusive) on the keys to be returned

     Definition Classes
       TreeMap → SortedMapLike

169. #### def view(from: Int, until: Int): IterableView[(A, B), TreeMap[A, B]]

     Creates a non-strict view of a slice of this iterable collection.

     Creates a non-strict view of a slice of this iterable collection.

     Note: the difference between `view` and `slice` is that `view` produces a view of the current iterable collection, whereas `slice` produces a new iterable collection.

     Note: `view(from, to)` is equivalent to `view.slice(from, to)`

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     from

       the index of the first element of the view

     until

       the index of the element following the view

     returns

       a non-strict view of a slice of this iterable collection, starting at index `from` and extending up to (but not including) index `until`.

     Definition Classes
       IterableLike → TraversableLike

170. #### def view: IterableView[(A, B), TreeMap[A, B]]

     Creates a non-strict view of this iterable collection.

     Creates a non-strict view of this iterable collection.

     returns

       a non-strict view of this iterable collection.

     Definition Classes
       IterableLike → TraversableLike

171. #### final def wait(): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

172. #### final def wait(arg0: Long, arg1: Int): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

173. #### final def wait(arg0: Long): Unit

     Definition Classes
       AnyRef
     Annotations
       @throws( ... )

174. #### def withDefault[B1 >: B](d: (A) ⇒ B1): Map[A, B1]

     The same map with a given default function.

     The same map with a given default function. Note: `get`, `contains`, `iterator`, `keys`, etc are not affected by `withDefault`.

     Invoking transformer methods (e.g. `map`) will not preserve the default value.

     d

       the function mapping keys to values, used for non-present keys

     returns

       a wrapper of the map with a default value

     Definition Classes
       Map

175. #### def withDefaultValue[B1 >: B](d: B1): Map[A, B1]

     The same map with a given default value.

     The same map with a given default value. Note: `get`, `contains`, `iterator`, `keys`, etc are not affected by `withDefaultValue`.

     Invoking transformer methods (e.g. `map`) will not preserve the default value.

     d

       default value used for non-present keys

     returns

       a wrapper of the map with a default value

     Definition Classes
       Map

176. #### def withFilter(p: ((A, B)) ⇒ Boolean): FilterMonadic[(A, B), TreeMap[A, B]]

     Creates a non-strict filter of this traversable collection.

     Creates a non-strict filter of this traversable collection.

     Note: the difference between `c filter p` and `c withFilter p` is that the former creates a new collection, whereas the latter only restricts the domain of subsequent `map`, `flatMap`, `foreach`, and `withFilter` operations.

     Note: might return different results for different runs, unless the underlying collection type is ordered.

     p

       the predicate used to test elements.

     returns

       an object of class `WithFilter`, which supports `map`, `flatMap`, `foreach`, and `withFilter` operations. All these operations apply to those elements of this traversable collection which satisfy the predicate `p`.

     Definition Classes
       TraversableLike → FilterMonadic

177. #### def zip[B](that: GenIterable[B]): TreeMap[(A, B)]

     [use case] Returns a immutable tree map formed from this immutable tree map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable tree map formed from this immutable tree map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is longer than the other, its remaining elements are ignored.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     returns

       a new immutable tree map containing pairs consisting of corresponding elements of this immutable tree map and `that`. The length of the returned collection is the minimum of the lengths of this immutable tree map and `that`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zip[A1 >: (A, B), B, That](that: GenIterable[B])(implicit bf: CanBuildFrom[TreeMap[A, B], (A1, B), That]): That

178. #### def zipAll[B](that: collection.Iterable[B], thisElem: A, thatElem: B): TreeMap[(A, B)]

     [use case] Returns a immutable tree map formed from this immutable tree map and another iterable collection by combining corresponding elements in pairs.

     [use case]

     Returns a immutable tree map formed from this immutable tree map and another iterable collection by combining corresponding elements in pairs. If one of the two collections is shorter than the other, placeholder elements are used to extend the shorter collection to the length of the longer.

     B

       the type of the second half of the returned pairs

     that

       The iterable providing the second half of each result pair

     thisElem

       the element to be used to fill up the result if this immutable tree map is shorter than `that`.

     thatElem

       the element to be used to fill up the result if `that` is shorter than this immutable tree map.

     returns

       a new immutable tree map containing pairs consisting of corresponding elements of this immutable tree map and `that`. The length of the returned collection is the maximum of the lengths of this immutable tree map and `that`. If this immutable tree map is shorter than `that`, `thisElem` values are used to pad the result. If `that` is shorter than this immutable tree map, `thatElem` values are used to pad the result.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipAll[B, A1 >: (A, B), That](that: GenIterable[B], thisElem: A1, thatElem: B)(implicit bf: CanBuildFrom[TreeMap[A, B], (A1, B), That]): That

179. #### def zipWithIndex: TreeMap[(A, Int)]

     [use case] Zips this immutable tree map with its indices.

     [use case]

     Zips this immutable tree map with its indices.

     returns

       A new immutable tree map containing pairs consisting of all elements of this immutable tree map paired with their index. Indices start at `0`.

     Definition Classes
       IterableLike → GenIterableLike
     Full Signature

     #### def zipWithIndex[A1 >: (A, B), That](implicit bf: CanBuildFrom[TreeMap[A, B], (A1, Int), That]): That

     Example:

     1. `List("a", "b", "c").zipWithIndex = List(("a", 0), ("b", 1), ("c", 2))`

180. #### def →[B](y: B): (TreeMap[A, B], B)

     Implicit information
       This member is added by an implicit conversion from TreeMap[A, B] to ArrowAssoc[TreeMap[A, B]] performed by method ArrowAssoc in scala.Predef.
     Definition Classes
       ArrowAssoc

### Shadowed Implicit Value Members

1. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TreeMap[A, B] to any2stringadd[TreeMap[A, B]] performed by method any2stringadd in scala.Predef.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (treeMap: any2stringadd[TreeMap[A, B]]).+(other)

   Definition Classes
     any2stringadd

2. #### def filter(p: ((A, B)) ⇒ Boolean): TraversableOnce[(A, B)]

   Implicit information
     This member is added by an implicit conversion from TreeMap[A, B] to MonadOps[(A, B)] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (treeMap: MonadOps[(A, B)]).filter(p)

   Definition Classes
     MonadOps

3. #### def flatMap[B](f: ((A, B)) ⇒ GenTraversableOnce[B]): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from TreeMap[A, B] to MonadOps[(A, B)] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (treeMap: MonadOps[(A, B)]).flatMap(f)

   Definition Classes
     MonadOps

4. #### def map[B](f: ((A, B)) ⇒ B): TraversableOnce[B]

   Implicit information
     This member is added by an implicit conversion from TreeMap[A, B] to MonadOps[(A, B)] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (treeMap: MonadOps[(A, B)]).map(f)

   Definition Classes
     MonadOps

5. #### def withFilter(p: ((A, B)) ⇒ Boolean): Iterator[(A, B)]

   Implicit information
     This member is added by an implicit conversion from TreeMap[A, B] to MonadOps[(A, B)] performed by method MonadOps in scala.collection.TraversableOnce.
   Shadowing
     This implicitly inherited member is shadowed by one or more members in this class.
     To access this member you can use a type ascription:

         (treeMap: MonadOps[(A, B)]).withFilter(p)

   Definition Classes
     MonadOps

### Inherited from Serializable

### Inherited from java.io.Serializable

### Inherited from SortedMap[A, B]

### Inherited from collection.SortedMap[A, B]

### Inherited from SortedMapLike[A, B, TreeMap[A, B]]

### Inherited from Sorted[A, TreeMap[A, B]]

### Inherited from Map[A, B]

### Inherited from MapLike[A, B, TreeMap[A, B]]

### Inherited from collection.Map[A, B]

### Inherited from collection.MapLike[A, B, TreeMap[A, B]]

### Inherited from Subtractable[A, TreeMap[A, B]]

### Inherited from PartialFunction[A, B]

### Inherited from (A) ⇒ B

### Inherited from GenMap[A, B]

### Inherited from GenMapLike[A, B, TreeMap[A, B]]

### Inherited from Iterable[(A, B)]

### Inherited from collection.Iterable[(A, B)]

### Inherited from IterableLike[(A, B), TreeMap[A, B]]

### Inherited from Equals

### Inherited from GenIterable[(A, B)]

### Inherited from GenIterableLike[(A, B), TreeMap[A, B]]

### Inherited from Traversable[(A, B)]

### Inherited from Immutable

### Inherited from collection.Traversable[(A, B)]

### Inherited from GenTraversable[(A, B)]

### Inherited from GenericTraversableTemplate[(A, B), Iterable]

### Inherited from TraversableLike[(A, B), TreeMap[A, B]]

### Inherited from GenTraversableLike[(A, B), TreeMap[A, B]]

### Inherited from Parallelizable[(A, B), ParMap[A, B]]

### Inherited from TraversableOnce[(A, B)]

### Inherited from GenTraversableOnce[(A, B)]

### Inherited from FilterMonadic[(A, B), TreeMap[A, B]]

### Inherited from HasNewBuilder[(A, B), TreeMap[A, B]]

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion CollectionsHaveToParArray from TreeMap[A, B] to CollectionsHaveToParArray[TreeMap[A, B], T]

### Inherited by implicit conversion MonadOps from TreeMap[A, B] to MonadOps[(A, B)]

### Inherited by implicit conversion any2stringadd from TreeMap[A, B] to any2stringadd[TreeMap[A, B]]

### Inherited by implicit conversion StringFormat from TreeMap[A, B] to StringFormat[TreeMap[A, B]]

### Inherited by implicit conversion Ensuring from TreeMap[A, B] to Ensuring[TreeMap[A, B]]

### Inherited by implicit conversion ArrowAssoc from TreeMap[A, B] to ArrowAssoc[TreeMap[A, B]]

### Inherited by implicit conversion alternateImplicit from TreeMap[A, B] to ForceImplicitAmbiguity

### Ungrouped